{ 
open Parser
}

let whitespace = [' ' '\t']+
let digit = ['0'-'9']
let alpha = ['a'-'z' 'A'-'Z' '_']
let alphanumeric = (alpha|digit)

rule read_token = parse
  | "SELECT"    { SELECT }
  | "AVG"       { AVG }
  | "MAX"       { MAX }
  | "MIN"       { MIN }
  | "SUM"       { SUM }
  | "COUNT"     { COUNT }
  | "DISTINCT"  { DISTINCT }
  | "FROM"      { FROM }
  | "LEFT"      { LEFT }
  | "RIGHT"     { RIGHT }
  | "CROSS"     { CROSS }
  | "UNION"     { UNION }
  | "JOIN"      { JOIN }
  | "ON"        { ON }
  | "GROUP"     { GROUP }
  | "BY"        { BY }
  | "*"         { ASTERISK }
  | "."         { DOT }
  | "="         { EQUALS_OPERATOR }
  | "("         { LEFT_PAREN }
  | ")"         { RIGHT_PAREN }
  | ","         { COMMA }
  | whitespace  { read_token lexbuf }
  | "WHERE"     { WHERE }
  | alpha alphanumeric* as ident      { IDENT ident }
  | eof         { EOF }
